Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1686)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1691)
@@ -14,10 +14,13 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added skip_time_do_lsm to allow for spin-ups without LSM. Various bugfixes:
+! Soil temperatures are now defined at the edges of the layers, calculation of
+! shb_eb corrected, prognostic equation for skin temperature corrected. Surface
+! fluxes are now directly transfered to atmosphere
 ! 
 ! Former revisions:
@@ -73,42 +76,51 @@
 !> DALES and UCLA-LES models.
 !>
-!> @todo Check dewfall parametrization for fog simulations.
-!> @todo Consider partial absorption of the net shortwave radiation by the surface layer.
-!> @todo Allow for water surfaces, check performance for bare soils.
-!> @todo Invert indices (running from -3 to 0. Currently: nzb_soil=0, nzt_soil=3)).
-!> @todo Implement surface runoff model (required when performing long-term LES with
-!>       considerable precipitation.
+!> @todo Consider partial absorption of the net shortwave radiation by the 
+!>       surface layer.
+!> @todo Allow for water surfaces
+!> @todo Invert indices (running from -3 to 0. Currently: nzb_soil=0, 
+!>       nzt_soil=3)).
+!> @todo Implement surface runoff model (required when performing long-term LES 
+!>       with considerable precipitation.
 !>
-!> @note  No time step criterion is required as long as the soil layers do not become
-!>        too thin.
+!> @note  No time step criterion is required as long as the soil layers do not 
+!>        become too thin.
 !------------------------------------------------------------------------------!
  MODULE land_surface_model_mod
  
-     USE arrays_3d,                                                            &
-         ONLY:  pt, pt_p, q_p, qsws, rif, shf, ts, us, z0, z0h
-
-     USE cloud_parameters,                                                     &
-         ONLY:  cp, l_d_r, l_v, precipitation_rate, rho_l, r_d, r_v
-
-     USE control_parameters,                                                   &
-         ONLY:  cloud_physics, dt_3d, humidity, intermediate_timestep_count,   &
-                initializing_actions, intermediate_timestep_count_max,         &
-                max_masks, precipitation, pt_surface, rho_surface,             &
-                roughness_length, surface_pressure, timestep_scheme, tsc,      &
-                z0h_factor, time_since_reference_point
-
-     USE indices,                                                              &
-         ONLY:  nbgp, nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner 
-
-     USE kinds
+    USE arrays_3d,                                                             &
+        ONLY:  hyp, pt, pt_p, q, q_p, ql, qsws, rif, shf, ts, us, vpt, z0, z0h
+
+    USE cloud_parameters,                                                      &
+        ONLY:  cp, hyrho, l_d_cp, l_d_r, l_v, prr, pt_d_t, rho_l, r_d, r_v
+
+    USE control_parameters,                                                    &
+        ONLY:  cloud_physics, dt_3d, humidity, intermediate_timestep_count,    &
+               initializing_actions, intermediate_timestep_count_max,          &
+               max_masks, precipitation, pt_surface, rho_surface,              &
+               roughness_length, surface_pressure, timestep_scheme, tsc,       &
+               z0h_factor, time_since_reference_point
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner 
+
+    USE kinds
 
     USE netcdf_control,                                                        &
         ONLY:  dots_label, dots_num, dots_unit
 
-     USE radiation_model_mod,                                                  &
-         ONLY:  radiation_scheme, rad_net, rad_sw_in, sigma_sb
-
-     USE statistics,                                                           &
-         ONLY:  hom, statistic_regions
+    USE pegrid
+
+    USE radiation_model_mod,                                                   &
+        ONLY:  force_radiation_call, radiation_scheme, rad_net, rad_sw_in,     &
+               rad_lw_out, sigma_sb
+        
+#if defined ( __rrtmg )
+    USE radiation_model_mod,                                                   &
+        ONLY:  rrtm_lwuflx_dt, rrtm_idrv
+#endif
+
+    USE statistics,                                                            &
+        ONLY:  hom, statistic_regions
 
     IMPLICIT NONE
@@ -144,7 +156,8 @@
                     soil_type = 3    !< soil type, 0: user-defined, 1-6: generic (see list)
 
-    LOGICAL :: conserve_water_content = .TRUE., & !< open or closed bottom surface for the soil model
-               dewfall = .TRUE.,                & !< allow/inhibit dewfall
-               land_surface = .FALSE.             !< flag parameter indicating wheather the lsm is used
+    LOGICAL :: conserve_water_content = .TRUE.,  & !< open or closed bottom surface for the soil model
+               dewfall = .TRUE.,                 & !< allow/inhibit dewfall
+               force_radiation_call_l = .FALSE., & !< flag parameter for unscheduled radiation model calls
+               land_surface = .FALSE.              !< flag parameter indicating wheather the lsm is used
 
 !   value 9999999.9_wp -> generic available or user-defined value must be set
@@ -160,4 +173,5 @@
                 hydraulic_conductivity = 9999999.9_wp,  & !< NAMELIST gamma_w_sat
                 ke = 0.0_wp,                            & !< Kersten number
+                lambda_h_sat = 0.0_wp,                  & !< heat conductivity for saturated soil
                 lambda_surface_stable = 9999999.9_wp,   & !< NAMELIST lambda_surface_s
                 lambda_surface_unstable = 9999999.9_wp, & !< NAMELIST lambda_surface_u
@@ -174,15 +188,14 @@
                 rd_d_rv,                                & !< r_d / r_v
                 saturation_moisture = 9999999.9_wp,     & !< NAMELIST m_sat
+                skip_time_do_lsm = 0.0_wp,              & !< LSM is not called before this time
                 vegetation_coverage = 9999999.9_wp,     & !< NAMELIST c_veg
                 wilting_point = 9999999.9_wp,           & !< NAMELIST m_wilt
                 z0_eb  = 9999999.9_wp,                  & !< NAMELIST z0 (lsm_par)
-                z0h_eb = 9999999.9_wp                    !< NAMELIST z0h (lsm_par)
+                z0h_eb = 9999999.9_wp                     !< NAMELIST z0h (lsm_par)
 
     REAL(wp), DIMENSION(nzb_soil:nzt_soil) :: &
-              ddz_soil,                     & !< 1/dz_soil
-              ddz_soil_stag,                & !< 1/dz_soil_stag
-              dz_soil,                      & !< soil grid spacing (center-center)
-              dz_soil_stag,                 & !< soil grid spacing (edge-edge) 
-              root_extr = 0.0_wp,           & !< root extraction
+              ddz_soil_stag,                  & !< 1/dz_soil_stag
+              dz_soil_stag,                   & !< soil grid spacing (center-center)
+              root_extr = 0.0_wp,             & !< root extraction
               root_fraction = (/9999999.9_wp, 9999999.9_wp,    &
                                 9999999.9_wp, 9999999.9_wp /), & !< distribution of root surface area to the individual soil layers
@@ -191,6 +204,8 @@
 
     REAL(wp), DIMENSION(nzb_soil:nzt_soil+1) ::   &
-              soil_temperature = (/290.0_wp, 287.0_wp, 285.0_wp,  283.0_wp,    &
-                                   283.0_wp /) !< soil temperature (K)
+              soil_temperature = (/290.0_wp, 287.0_wp, 285.0_wp,  283.0_wp,    & !< soil temperature (K)
+                                   283.0_wp /),                                &                                   
+              ddz_soil,                                                        & !< 1/dz_soil
+              dz_soil                                                            !< soil grid spacing (edge-edge)
 
 #if defined( __nopointer )
@@ -218,5 +233,5 @@
 !
 !-- Energy balance variables                
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::                                   &
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
               alpha_vg,         & !< coef. of Van Genuchten
               c_liq,            & !< liquid water coverage (of vegetated area)
@@ -232,7 +247,6 @@
               lai,              & !< leaf area index
               lai_av,           & !< average of lai
-              lambda_h_sat,     & !< heat conductivity for dry soil
-              lambda_surface_s,    & !< coupling between surface and soil (depends on vegetation type)
-              lambda_surface_u,    & !< coupling between surface and soil (depends on vegetation type)
+              lambda_surface_s, & !< coupling between surface and soil (depends on vegetation type)
+              lambda_surface_u, & !< coupling between surface and soil (depends on vegetation type)
               l_vg,             & !< coef. of Van Genuchten
               m_fc,             & !< soil moisture at field capacity (m3/m3)
@@ -253,11 +267,12 @@
               r_a_av,           & !< avergae of r_a
               r_canopy,         & !< canopy resistance
-              r_soil,           & !< soil resitance
+              r_soil,           & !< soil resistance
               r_soil_min,       & !< minimum soil resistance
               r_s,              & !< total surface resistance (combination of r_soil and r_canopy)
-              r_s_av,           & !< avergae of r_s
+              r_s_av,           & !< average of r_s
               r_canopy_min,     & !< minimum canopy (stomatal) resistance
               shf_eb,           & !< surface flux of sensible heat
               shf_eb_av           !< average of shf_eb
+
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
@@ -472,7 +487,8 @@
            lsm_swap_timelevel, l_vangenuchten, min_canopy_resistance,          &
            min_soil_resistance, n_vangenuchten, residual_moisture, rho_cp,     &
-           rho_lv, root_fraction, saturation_moisture, soil_moisture,          &
-           soil_temperature, soil_type, soil_type_name, vegetation_coverage,   &
-           veg_type, veg_type_name, wilting_point, z0_eb, z0h_eb
+           rho_lv, root_fraction, saturation_moisture, skip_time_do_lsm,       &
+           soil_moisture, soil_temperature, soil_type, soil_type_name,         &
+           vegetation_coverage, veg_type, veg_type_name, wilting_point, z0_eb, &
+           z0h_eb
 
 !
@@ -483,5 +499,4 @@
            zs
 
-
 !
 !-- Public 2D output variables
@@ -490,5 +505,4 @@
            qsws_soil_eb, qsws_soil_eb_av, qsws_veg_eb, qsws_veg_eb_av,         &
            r_a, r_a_av, r_s, r_s_av, shf_eb, shf_eb_av
-
 
 !
@@ -565,5 +579,4 @@
        ALLOCATE ( lai(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( l_vg(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_h_sat(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( lambda_surface_u(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( lambda_surface_s(nysg:nyng,nxlg:nxrg) )
@@ -612,8 +625,10 @@
        INTEGER(iwp) ::  k !< running index
 
+       REAL(wp) :: pt_1   !< potential temperature at first grid level
+
 
 !
 !--    Calculate Exner function
-       exn       = ( surface_pressure / 1000.0_wp )**0.286_wp
+       exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 
 
@@ -674,16 +689,17 @@
 !
 !--    Calculate grid spacings. Temperature and moisture are defined at
-!--    the center of the soil layers, whereas gradients/fluxes are defined
-!--    at the edges (_stag)
-       dz_soil_stag(nzb_soil) = zs(nzb_soil)
-
-       DO k = nzb_soil+1, nzt_soil
-          dz_soil_stag(k) = zs(k) - zs(k-1)
+!--    the edges of the soil layers (_stag), whereas gradients/fluxes are defined
+!--    at the centers
+       dz_soil(nzb_soil) = zs(nzb_soil)
+
+       DO  k = nzb_soil+1, nzt_soil
+          dz_soil(k) = zs(k) - zs(k-1)
        ENDDO
-
-       DO k = nzb_soil, nzt_soil-1
-          dz_soil(k) = 0.5 * (dz_soil_stag(k+1) + dz_soil_stag(k))
+       dz_soil(nzt_soil+1) = dz_soil(nzt_soil)
+
+       DO  k = nzb_soil, nzt_soil-1
+          dz_soil_stag(k) = 0.5_wp * (dz_soil(k+1) + dz_soil(k))
        ENDDO
-       dz_soil(nzt_soil) = dz_soil_stag(nzt_soil)
+       dz_soil_stag(nzt_soil) = dz_soil(nzt_soil)
 
        ddz_soil      = 1.0_wp / dz_soil
@@ -752,5 +768,5 @@
 !--       (make sure that the soil moisture does not drop below the permanent
 !--       wilting point) -> problems with devision by zero)
-          DO k = nzb_soil, nzt_soil
+          DO  k = nzb_soil, nzt_soil
              t_soil(k,:,:)    = soil_temperature(k)
              m_soil(k,:,:)    = MAX(soil_moisture(k),m_wilt(:,:))
@@ -761,5 +777,6 @@
 !
 !--       Calculate surface temperature
-          t_surface = pt_surface * exn
+          t_surface   = pt_surface * exn
+          t_surface_p = t_surface
 
 !
@@ -770,11 +787,16 @@
                 k = nzb_s_inner(j,i)
 
+                IF ( cloud_physics )  THEN
+                   pt_1 = pt(k+1,j,i) + l_d_cp * pt_d_t(k+1) * ql(k+1,j,i)
+                ELSE
+                   pt_1 = pt(k+1,j,i)
+                ENDIF
+
 !
 !--             Assure that r_a cannot be zero at model start
-                IF ( pt(k+1,j,i) == pt(k,j,i) )  pt(k+1,j,i) = pt(k+1,j,i)     &
-                                                 + 1.0E-10_wp
-
-                us(j,i) = 0.1_wp
-                ts(j,i) = (pt(k+1,j,i) - pt(k,j,i)) / r_a(j,i)
+                IF ( pt_1 == pt(k,j,i) )  pt_1 = pt_1 + 1.0E-10_wp
+
+                us(j,i)  = 0.1_wp
+                ts(j,i)  = (pt_1 - pt(k,j,i)) / r_a(j,i)
                 shf(j,i) = - us(j,i) * ts(j,i)
              ENDDO
@@ -794,13 +816,5 @@
        ENDIF
 
-!
-!--    Calculate saturation soil heat conductivity
-       lambda_h_sat(:,:) = lambda_h_sm ** (1.0_wp - m_sat(:,:)) *              &
-                           lambda_h_water ** m_sat(:,:)
-
-
-
-
-       DO k = nzb_soil, nzt_soil
+       DO  k = nzb_soil, nzt_soil
           root_fr(k,:,:) = root_fraction(k)
        ENDDO
@@ -838,5 +852,5 @@
 
           IF ( ANY( root_fraction == 9999999.9_wp ) )  THEN
-             DO k = nzb_soil, nzt_soil
+             DO  k = nzb_soil, nzt_soil
                 root_fr(k,:,:) = root_distribution(k,veg_type)
                 root_fraction(k) = root_distribution(k,veg_type)
@@ -886,28 +900,19 @@
 
 !
-!--    Calculate humidity at the surface
-       IF ( humidity )  THEN
-          CALL calc_q_surface
-       ENDIF
-
-
-
-!
 !--    Add timeseries for land surface model
-
-       dots_label(dots_num+1) = "ghf_eb"
-       dots_label(dots_num+2) = "shf_eb"
-       dots_label(dots_num+3) = "qsws_eb"
-       dots_label(dots_num+4) = "qsws_liq_eb"
-       dots_label(dots_num+5) = "qsws_soil_eb"
-       dots_label(dots_num+6) = "qsws_veg_eb"
-       dots_unit(dots_num+1:dots_num+6) = "W/m2"
-
-       dots_label(dots_num+7) = "r_a"
-       dots_label(dots_num+8) = "r_s"
-       dots_unit(dots_num+7:dots_num+8) = "s/m"
-
        dots_soil = dots_num + 1
        dots_num  = dots_num + 8
+
+       dots_label(dots_soil) = "ghf_eb"
+       dots_label(dots_soil+1) = "shf_eb"
+       dots_label(dots_soil+2) = "qsws_eb"
+       dots_label(dots_soil+3) = "qsws_liq_eb"
+       dots_label(dots_soil+4) = "qsws_soil_eb"
+       dots_label(dots_soil+5) = "qsws_veg_eb"
+       dots_label(dots_soil+6) = "r_a"
+       dots_label(dots_soil+7) = "r_s"
+
+       dots_unit(dots_soil:dots_soil+5) = "W/m2"
+       dots_unit(dots_soil+6:dots_soil+7) = "s/m"
 
        RETURN
@@ -921,9 +926,4 @@
 ! ------------
 !> Solver for the energy balance at the surface.
-!> @note Surface fluxes are calculated in the land surface model, but these are
-!>       not used in the atmospheric code. The fluxes are calculated afterwards in
-!>       prandtl_fluxes using the surface values of temperature and humidity as
-!>       provided by the land surface model. In this way, the fluxes in the land
-!>       surface model are not equal to the ones calculated in prandtl_fluxes
 !------------------------------------------------------------------------------!
     SUBROUTINE lsm_energy_balance
@@ -940,5 +940,4 @@
                    f3,          & !< resistance correction term 3
                    m_min,       & !< minimum soil moisture
-                   T_1,         & !< actual temperature at first grid point
                    e,           & !< water vapour pressure
                    e_s,         & !< water vapour saturation pressure
@@ -954,6 +953,7 @@
                    f_shf,       & !< factor for shf_eb
                    lambda_surface, & !< Current value of lambda_surface
-                   m_liq_eb_max   !< maxmimum value of the liq. water reservoir
-
+                   m_liq_eb_max,   & !< maxmimum value of the liq. water reservoir
+                   pt_1,        & !< potential temperature at first grid level
+                   qv_1           !< specific humidity at first grid level
 
 !
@@ -961,8 +961,6 @@
        exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 
-       
-
-       DO i = nxlg, nxrg
-          DO j = nysg, nyng
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              k = nzb_s_inner(j,i)
 
@@ -980,6 +978,13 @@
 !--          time step is used here. Note that this formulation is the
 !--          equivalent to the ECMWF formulation using drag coefficients
-             r_a(j,i) = (pt(k+1,j,i) - pt(k,j,i)) / (ts(j,i) * us(j,i) +       &
-                         1.0E-20_wp)
+             IF ( cloud_physics )  THEN
+                pt_1 = pt(k+1,j,i) + l_d_cp * pt_d_t(k+1) * ql(k+1,j,i)
+                qv_1 = q(k+1,j,i) - ql(k+1,j,i)
+             ELSE
+                pt_1 = pt(k+1,j,i)
+                qv_1 = q(k+1,j,i)
+             ENDIF
+
+             r_a(j,i) = (pt_1 - pt(k,j,i)) / (ts(j,i) * us(j,i) + 1.0E-20_wp)
 
 !
@@ -1002,12 +1007,12 @@
 !--          f2 = 0 for very dry soils
              m_total = 0.0_wp
-             DO ks = nzb_soil, nzt_soil
+             DO  ks = nzb_soil, nzt_soil
                  m_total = m_total + root_fr(ks,j,i)                           &
                            * MAX(m_soil(ks,j,i),m_wilt(j,i))
              ENDDO 
 
-             IF ( m_total .GT. m_wilt(j,i) .AND. m_total .LT. m_fc(j,i) )  THEN
+             IF ( m_total > m_wilt(j,i) .AND. m_total < m_fc(j,i) )  THEN
                 f2 = ( m_total - m_wilt(j,i) ) / (m_fc(j,i) - m_wilt(j,i) )
-             ELSEIF ( m_total .GE. m_fc(j,i) )  THEN
+             ELSEIF ( m_total >= m_fc(j,i) )  THEN
                 f2 = 1.0_wp
              ELSE
@@ -1025,5 +1030,5 @@
 !
 !--             Calculate vapour pressure
-                e  = q_p(k+1,j,i) * surface_pressure / 0.622_wp
+                e  = qv_1 * surface_pressure / 0.622_wp
                 f3 = EXP ( -g_d(j,i) * (e_s - e) )
              ELSE
@@ -1067,8 +1072,8 @@
 !--          In case of dewfall, set evapotranspiration to zero
 !--          All super-saturated water is then removed from the air
-             IF ( humidity .AND. dewfall .AND. q_s .LE. q_p(k+1,j,i) )  THEN
+             IF ( humidity .AND. q_s <= qv_1 )  THEN
                 r_canopy(j,i) = 0.0_wp
                 r_soil(j,i)   = 0.0_wp
-             ENDIF 
+             ENDIF
 
 !
@@ -1085,5 +1090,5 @@
 !--          If soil moisture is below wilting point, plants do no longer
 !--          transpirate.
-!              IF ( m_soil(k,j,i) .LT. m_wilt(j,i) )  THEN
+!              IF ( m_soil(k,j,i) < m_wilt(j,i) )  THEN
 !                 f_qsws_veg = 0.0_wp
 !              ENDIF
@@ -1094,5 +1099,5 @@
 !--          air.
              IF ( humidity )  THEN
-                IF ( q_s .LE. q_p(k+1,j,i) )  THEN
+                IF ( q_s <= qv_1 )  THEN
                    IF ( .NOT. dewfall )  THEN
                       f_qsws_veg  = 0.0_wp
@@ -1114,16 +1119,16 @@
              dq_s_dt = 0.622_wp * e_s_dt / surface_pressure
 
-             T_1 = pt_p(k+1,j,i) * exn
-
 !
 !--          Add LW up so that it can be removed in prognostic equation
-             rad_net_l(j,i) = rad_net(j,i) + sigma_sb * t_surface(j,i) ** 4
+             rad_net_l(j,i) = rad_net(j,i) + rad_lw_out(nzb,j,i)
+
 
              IF ( humidity )  THEN
-
+#if defined ( __rrtmg )
 !
 !--             Numerator of the prognostic equation
-                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb * t_surface(j,i) ** 4&
-                         + f_shf / exn * T_1 + f_qsws * ( q_p(k+1,j,i) - q_s   &
+                coef_1 = rad_net_l(j,i) + rrtm_lwuflx_dt(0,nzb)                &
+                         * t_surface(j,i) - rad_lw_out(nzb,j,i)                &
+                         + f_shf * pt_1 + f_qsws * ( qv_1 - q_s                &
                          + dq_s_dt * t_surface(j,i) ) + lambda_surface         &
                          * t_soil(nzb_soil,j,i)
@@ -1131,14 +1136,42 @@
 !
 !--             Denominator of the prognostic equation
-                coef_2 = 4.0_wp * sigma_sb * t_surface(j,i) ** 3 + f_qsws      &
-                         * dq_s_dt + lambda_surface + f_shf / exn
-
+                coef_2 = rrtm_lwuflx_dt(0,nzb) + f_qsws * dq_s_dt              &
+                         + lambda_surface + f_shf / exn
+#else
+
+!
+!--             Numerator of the prognostic equation
+                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb                    &
+                         * t_surface(j,i) ** 4                                 &
+                         + f_shf * pt_1 + f_qsws * ( qv_1                      &
+                         - q_s + dq_s_dt * t_surface(j,i) )                    &
+                         + lambda_surface * t_soil(nzb_soil,j,i)
+
+!
+!--                Denominator of the prognostic equation
+                   coef_2 = 4.0_wp * sigma_sb * t_surface(j,i) ** 3 + f_qsws   &
+                            * dq_s_dt + lambda_surface + f_shf / exn
+ 
+#endif
              ELSE
 
+#if defined ( __rrtmg )
 !
 !--             Numerator of the prognostic equation
-                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb * t_surface(j,i) ** 4&
-                         + f_shf / exn * T_1 + lambda_surface                  &
+                coef_1 = rad_net_l(j,i) + rrtm_lwuflx_dt(0,nzb)                &
+                         * t_surface(j,i) - rad_lw_out(nzb,j,i)                &
+                         + f_shf * pt_1  + lambda_surface                      &
                          * t_soil(nzb_soil,j,i)
+
+!
+!--             Denominator of the prognostic equation
+                coef_2 = rrtm_lwuflx_dt(0,nzb) + lambda_surface + f_shf / exn
+#else
+
+!
+!--             Numerator of the prognostic equation
+                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb                    &
+                          * t_surface(j,i) ** 4 + f_shf * pt_1                 &
+                          + lambda_surface * t_soil(nzb_soil,j,i)
 
 !
@@ -1146,6 +1179,7 @@
                 coef_2 = 4.0_wp * sigma_sb * t_surface(j,i) ** 3               &
                          + lambda_surface + f_shf / exn
-
-             ENDIF
+#endif
+             ENDIF
+
 
              tend = 0.0_wp
@@ -1159,56 +1193,87 @@
 !
 !--          Add RK3 term
-             t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)              &
-                                * tt_surface_m(j,i)
-
-!
-!--          Calculate true tendency
-             tend = (t_surface_p(j,i) - t_surface(j,i) - dt_3d * tsc(3)        &
-                    * tt_surface_m(j,i)) / (dt_3d  * tsc(2))
-!
-!--          Calculate t_surface tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   tt_surface_m(j,i) = tend
-                ELSEIF ( intermediate_timestep_count <                         &
-                         intermediate_timestep_count_max )  THEN
-                   tt_surface_m(j,i) = -9.5625_wp * tend + 5.3125_wp           &
-                                       * tt_surface_m(j,i)
+             IF ( c_surface /= 0.0_wp )  THEN
+
+                t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)           &
+                                   * tt_surface_m(j,i)
+
+!
+!--             Calculate true tendency
+                tend = (t_surface_p(j,i) - t_surface(j,i) - dt_3d * tsc(3)     &
+                       * tt_surface_m(j,i)) / (dt_3d  * tsc(2))
+!
+!--             Calculate t_surface tendencies for the next Runge-Kutta step
+                IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                   IF ( intermediate_timestep_count == 1 )  THEN
+                      tt_surface_m(j,i) = tend
+                   ELSEIF ( intermediate_timestep_count <                      &
+                            intermediate_timestep_count_max )  THEN
+                      tt_surface_m(j,i) = -9.5625_wp * tend + 5.3125_wp        &
+                                          * tt_surface_m(j,i)
+                   ENDIF
                 ENDIF
-             ENDIF
-
-             pt_p(k,j,i) = t_surface_p(j,i) / exn
+
+             ENDIF
+
+!
+!--          In case of fast changes in the skin temperature, it is required to
+!--          update the radiative fluxes in order to keep the solution stable
+             IF ( ABS( t_surface_p(j,i) - t_surface(j,i) ) > 0.2_wp )  THEN
+                force_radiation_call_l = .TRUE.
+             ENDIF
+
+             pt(k,j,i) = t_surface_p(j,i) / exn
+
 !
 !--          Calculate fluxes
-             rad_net_l(j,i)   = rad_net_l(j,i) + 3.0_wp * sigma_sb                 &
-                              * t_surface(j,i)**4 - 4.0_wp * sigma_sb          &
-                              * t_surface(j,i)**3 * t_surface_p(j,i)
+#if defined ( __rrtmg )
+             rad_net_l(j,i)   = rad_net_l(j,i) + rrtm_lwuflx_dt(0,nzb)         &
+                                * t_surface(j,i) - rad_lw_out(nzb,j,i)         &
+                                - rrtm_lwuflx_dt(0,nzb) * t_surface_p(j,i)
+
+             IF ( rrtm_idrv == 1 )  THEN
+                rad_net(j,i) = rad_net_l(j,i)
+                rad_lw_out(nzb,j,i) = rad_lw_out(nzb,j,i)                      &
+                                      + rrtm_lwuflx_dt(0,nzb)                  &
+                                      * ( t_surface_p(j,i) - t_surface(j,i) )
+             ENDIF
+#else
+             rad_net_l(j,i)   = rad_net_l(j,i) + 3.0_wp * sigma_sb             &
+                                * t_surface(j,i)**4 - 4.0_wp * sigma_sb        &
+                                * t_surface(j,i)**3 * t_surface_p(j,i)
+             rad_net(j,i) = rad_net_l(j,i)
+#endif
+
              ghf_eb(j,i)    = lambda_surface * (t_surface_p(j,i)               &
                               - t_soil(nzb_soil,j,i))
-             shf_eb(j,i)    = - f_shf  * ( pt_p(k+1,j,i) - pt_p(k,j,i) )
+
+             shf_eb(j,i)    = - f_shf * ( pt_1 - pt(k,j,i) )
+
+             shf(j,i) = shf_eb(j,i) / rho_cp
 
              IF ( humidity )  THEN
-                qsws_eb(j,i)  = - f_qsws    * ( q_p(k+1,j,i) - q_s + dq_s_dt   &
+                qsws_eb(j,i)  = - f_qsws    * ( qv_1 - q_s + dq_s_dt           &
                                 * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )
 
-                qsws_veg_eb(j,i)  = - f_qsws_veg  * ( q_p(k+1,j,i) - q_s       &
+                qsws(j,i) = qsws_eb(j,i) / rho_lv
+
+                qsws_veg_eb(j,i)  = - f_qsws_veg  * ( qv_1 - q_s               &
                                     + dq_s_dt * t_surface(j,i) - dq_s_dt       &
                                     * t_surface_p(j,i) )
 
-                qsws_soil_eb(j,i) = - f_qsws_soil * ( q_p(k+1,j,i) - q_s       &
+                qsws_soil_eb(j,i) = - f_qsws_soil * ( qv_1 - q_s               &
                                     + dq_s_dt * t_surface(j,i) - dq_s_dt       &
                                     * t_surface_p(j,i) )
 
-                qsws_liq_eb(j,i)  = - f_qsws_liq  * ( q_p(k+1,j,i) - q_s       &
+                qsws_liq_eb(j,i)  = - f_qsws_liq  * ( qv_1 - q_s               &
                                     + dq_s_dt * t_surface(j,i) - dq_s_dt       &
                                     * t_surface_p(j,i) )
              ENDIF
-
 !
 !--          Calculate the true surface resistance
-             IF ( qsws_eb(j,i) .EQ. 0.0_wp )  THEN
+             IF ( qsws_eb(j,i) == 0.0_wp )  THEN
                 r_s(j,i) = 1.0E10_wp
              ELSE
-                r_s(j,i) = - rho_lv * ( q_p(k+1,j,i) - q_s + dq_s_dt           &
+                r_s(j,i) = - rho_lv * ( qv_1 - q_s + dq_s_dt                   &
                            * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )     &
                            / qsws_eb(j,i) - r_a(j,i)
@@ -1228,11 +1293,11 @@
 !--                Add precipitation to liquid water reservoir, if possible.
 !--                Otherwise, add the water to bare soil fraction.
-                   IF ( m_liq_eb(j,i) .EQ. m_liq_eb_max )  THEN
+                   IF ( m_liq_eb(j,i) /= m_liq_eb_max )  THEN
                       qsws_liq_eb(j,i) = qsws_liq_eb(j,i)                      &
-                                       + c_veg(j,i) * precipitation_rate(j,i)  &
+                                       + c_veg(j,i) * prr(k,j,i) * hyrho(k)    &
                                        * 0.001_wp * rho_l * l_v
                    ELSE
                       qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                    &
-                                        + c_veg(j,i) * precipitation_rate(j,i) &
+                                        + c_veg(j,i) * prr(k,j,i) * hyrho(k)   &
                                         * 0.001_wp * rho_l * l_v
                    ENDIF
@@ -1241,10 +1306,12 @@
 !--                coverage.
                    qsws_soil_eb(j,i) = qsws_soil_eb(j,i) * (1.0_wp             &
-                                       - c_veg(j,i)) * precipitation_rate(j,i) &
+                                       - c_veg(j,i)) * prr(k,j,i) * hyrho(k)   &
                                        * 0.001_wp * rho_l * l_v
                 ENDIF
+
 !
 !--             If the air is saturated, check the reservoir water level
-                IF ( q_s .LE. q_p(k+1,j,i))  THEN
+                IF ( qsws_eb(j,i) < 0.0_wp )  THEN
+
 !
 !--                Check if reservoir is full (avoid values > m_liq_eb_max)
@@ -1252,5 +1319,5 @@
 !--                case qsws_veg_eb is zero anyway (because c_liq = 1),       
 !--                so that tend is zero and no further check is needed
-                   IF ( m_liq_eb(j,i) .EQ. m_liq_eb_max )  THEN
+                   IF ( m_liq_eb(j,i) == m_liq_eb_max )  THEN
                       qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                    &
                                            + qsws_liq_eb(j,i)
@@ -1262,5 +1329,5 @@
 !--                let the water enter the liquid water reservoir as dew on the
 !--                plant
-                   IF ( qsws_veg_eb(j,i) .LT. 0.0_wp )  THEN
+                   IF ( qsws_veg_eb(j,i) < 0.0_wp )  THEN
                       qsws_liq_eb(j,i) = qsws_liq_eb(j,i) + qsws_veg_eb(j,i)
                       qsws_veg_eb(j,i) = 0.0_wp
